<?php

namespace GGM\ProductManagerImplementation\Controller\Index;

use Exception;
use Magento\Framework\App\Action\Action;
use GGM\ProductManagerImplementation\ProductManagerMagento2;
use Magento\Framework\App\Action\Context;
use Magento\Framework\App\Area;
use Magento\Framework\App\Request\InvalidRequestException;
use Magento\Framework\App\RequestInterface;
use Magento\Framework\App\State as AppState;
use Magento\Framework\Exception\AuthenticationException;

/**
 * Class Index
 */
class Index extends Action
{
    /**
     * @var ProductManagerMagento2\Magento2Router
     */
    protected $router;

    /**
     * @var AppState
     */
    protected $appState;

    /**
     * Index constructor.
     *
     * @param Context $context
     * @param ProductManagerMagento2\Magento2Router $router
     * @param AppState $appState
     */
    public function __construct(
        Context $context,
        ProductManagerMagento2\Magento2Router $router,
        AppState $appState
    ) {
        $this->router = $router;
        $this->appState = $appState;

        parent::__construct($context);
    }

    /**
     * {@inheritdoc}
     *
     * @throws AuthenticationException
     */
    public function execute()
    {
        ob_start();
        ini_set('display_errors', 1);
        ini_set('html_errors', 1);

        try {
            $this->appState->setAreaCode(Area::AREA_ADMINHTML);
        } catch (Exception $e) {}

        $this->router->execute();

        exit();
    }

    /**
     * @param RequestInterface $request
     *
     * @return bool|null
     */
    public function validateForCsrf(RequestInterface $request): ?bool
    {
        return true;
    }

    /**
     * @param RequestInterface $request
     *
     * @return InvalidRequestException|null
     */
    public function createCsrfValidationException(RequestInterface $request): ?InvalidRequestException
    {
        return null;
    }
}